/*
 * ModelagemEstáticaView.java
 */

package modelagemestática;

import java.awt.HeadlessException;
import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.image.BufferedImage;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFrame;
import java.io.*;
import java.net.*;
import javax.swing.*;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * The application's main frame.
 */
public class ModelagemEstáticaView extends FrameView {

private Socket armazena_cliente; // precisa do socket do cliente para mandar mensagens(*SOCKET*)
private static String IP;
private static int Porta;
private Config_Conx a = new Config_Conx();
private static int error_conn_server;
public static int valor;

    public ModelagemEstáticaView(SingleFrameApplication app) { //
        super(app);

        initComponents();
             JFrame mainFrame = ModelagemEstáticaApp.getApplication().getMainFrame();
             mainFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
             //mainFrame.setExtendedState(JFrame.MAXIMIZED_BOTH);
        error_conn_server = 0;
        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                statusMessageLabel.setText("");
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                statusAnimationLabel.setIcon(busyIcons[busyIconIndex]);
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        statusAnimationLabel.setIcon(idleIcon);
        progressBar.setVisible(false);

             mainFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        statusAnimationLabel.setIcon(busyIcons[0]);
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(true);
                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    statusAnimationLabel.setIcon(idleIcon);
                    progressBar.setVisible(false);
                    progressBar.setValue(0);
                } else if ("message".equals(propertyName)) {
                    String text = (String)(evt.getNewValue());
                    statusMessageLabel.setText((text == null) ? "" : text);
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer)(evt.getNewValue());
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(false);
                    progressBar.setValue(value);
                }
            }
        });

       
             BufferedImage image = new BufferedImage(16, 16, BufferedImage.TYPE_INT_ARGB); // tirar ícone Java da janela
             mainFrame.setIconImage(image);
        
    }

    public void Armazena(Socket cliente) {
         armazena_cliente = cliente; // guarda o cliente
         valor = 0;
    }

    @Action
   /* public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = ModelagemEstáticaApp.getApplication().getMainFrame();
            aboutBox = new ModelagemEstáticaAboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
             
        }
      //  ModelagemEstáticaApp.getApplication().show(aboutBox);
    }*/

    private void Loop_Login() throws HeadlessException {
        // TODO add your handling code here:
        // Verificar se o usuário existe
        // criar conexão por sockets com o programa servidor
        // ESTE É O CLIENTE
       
        try {
            // TODO add your handling code here:
            
                   
             IP = a.IP_TOTAL;
            
           if((a.Porta_TOTAL).equals("")){ // se vazio o campo
                Porta = 1034; // porta padrão
            }else{
            //converter Porta_TOTAL para inteiro
            Porta = Integer.parseInt((a.Porta_TOTAL));
            }

            if(IP.equals("...")){ // se IP estiver em branco, então adiciona localhost (padrão)
            IP = "localhost";
            }

             System.out.println("IP_EN = "+IP);
             System.out.println("PORTA_EN = "+Porta);


            Socket cliente = new Socket(IP, Porta); // VAI TER QUE MANTER O SOCKET
            cliente.setSoTimeout(3000);

            Armazena(cliente);
            DataInputStream in = new DataInputStream(armazena_cliente.getInputStream()); // receber dados
            DataOutputStream out = new DataOutputStream(armazena_cliente.getOutputStream()); // enviar dados


            // envia opção 2
            out.writeInt(2);

            int aux = 0;
            int k = 0;


                String Pega_Senha = new String(Senha.getPassword());
                out.writeUTF(Login.getText()); // envia o login para o servidor
                out.writeUTF(Pega_Senha); // envia a senha para o servidor
                int status = in.readInt();
                System.out.println("Status " + status);
                if (status == 2) {


                     // pegar tipo do usuário
                    String tipo_GER_PROJ = new String();
                    String tipo_ANA_SIS = new String();
                    String tipo_DESG = new String();
                    String tipo_PROG = new String();
                    String tipo_TEST = new String();

                    tipo_GER_PROJ = in.readUTF();
                    tipo_ANA_SIS = in.readUTF();
                    tipo_DESG = in.readUTF();
                    tipo_PROG = in.readUTF();
                    tipo_TEST = in.readUTF();

                    System.out.println(tipo_GER_PROJ+tipo_ANA_SIS+tipo_DESG+tipo_PROG+tipo_TEST);

                    //caso sim, prossegue
                    JFrame mainFrame = ModelagemEstáticaApp.getApplication().getMainFrame();
                    Op opc = new Op(mainFrame, armazena_cliente, Login.getText(), tipo_GER_PROJ, tipo_ANA_SIS, tipo_DESG, tipo_PROG, tipo_TEST);
                    mainFrame.setVisible(false);
                    
                    Login.setText(null);
                    Senha.setText(null);
                   // Login.setEditable(false);
                   // Senha.setEditable(false);
                    //SAIR.setEnabled(false);
                    //Entra_Cadastro_Usuario.setEnabled(false);
                    //menuBar.setVisible(false);
                    opc.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
                    opc.setVisible(true);
                    k = 1;

                } else {
                    if (status == 0) {
                        // usuario inexistente
                        Login.setText(null);
                        Senha.setText(null);
                        k = 0;
                        JOptionPane.showMessageDialog(null, "Usuário Inexistente", "Erro", JOptionPane.ERROR_MESSAGE, null);
                    } else {
                        if (status == 1) {
                            // senha inválida
                            Login.setText(null);
                            Senha.setText(null);
                            k = 0;
                            JOptionPane.showMessageDialog(null, "Senha Inválida", "Erro", JOptionPane.ERROR_MESSAGE, null);
                        }
                    }
                }


           
        } catch (UnknownHostException ex) {
            Logger.getLogger(ModelagemEstáticaView.class.getName()).log(Level.SEVERE, null, ex);
             JOptionPane.showMessageDialog(null, "Servidor Não Encontrado!", "Erro", JOptionPane.ERROR_MESSAGE, null);
             error_conn_server = 1;
        } catch (IOException ex) {
            Logger.getLogger(ModelagemEstáticaView.class.getName()).log(Level.SEVERE, null, ex);
             JOptionPane.showMessageDialog(null, "Servidor Não Encontrado!", "Erro", JOptionPane.ERROR_MESSAGE, null);
             error_conn_server = 1;
        }

       
       
    }


    






    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        Entra_Cadastro_Usuario = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel3 = new javax.swing.JLabel();
        SAIR = new javax.swing.JButton();
        Login = new javax.swing.JTextField();
        Senha = new javax.swing.JPasswordField();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu Conf_Menu = new javax.swing.JMenu();
        javax.swing.JMenuItem Conf_Con = new javax.swing.JMenuItem();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(modelagemestática.ModelagemEstáticaApp.class).getContext().getResourceMap(ModelagemEstáticaView.class);
        mainPanel.setBackground(resourceMap.getColor("mainPanel.background")); // NOI18N
        mainPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        mainPanel.setForeground(resourceMap.getColor("mainPanel.foreground")); // NOI18N
        mainPanel.setMinimumSize(new java.awt.Dimension(400, 400));
        mainPanel.setName("mainPanel"); // NOI18N
        mainPanel.setPreferredSize(new java.awt.Dimension(400, 400));

        Entra_Cadastro_Usuario.setText(resourceMap.getString("Entra_Cadastro_Usuario.text")); // NOI18N
        Entra_Cadastro_Usuario.setName("Entra_Cadastro_Usuario"); // NOI18N
        Entra_Cadastro_Usuario.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Entra_Cadastro_UsuarioActionPerformed(evt);
            }
        });

        jLabel1.setFont(resourceMap.getFont("jLabel1.font")); // NOI18N
        jLabel1.setForeground(resourceMap.getColor("jLabel1.foreground")); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        jLabel1.setName("jLabel1"); // NOI18N

        jLabel2.setFont(resourceMap.getFont("jLabel2.font")); // NOI18N
        jLabel2.setForeground(resourceMap.getColor("jSeparator1.foreground")); // NOI18N
        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jSeparator1.setBackground(resourceMap.getColor("jSeparator1.background")); // NOI18N
        jSeparator1.setForeground(resourceMap.getColor("jSeparator1.foreground")); // NOI18N
        jSeparator1.setName("jSeparator1"); // NOI18N

        jLabel3.setFont(resourceMap.getFont("jLabel3.font")); // NOI18N
        jLabel3.setForeground(resourceMap.getColor("jSeparator1.foreground")); // NOI18N
        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        SAIR.setText(resourceMap.getString("SAIR.text")); // NOI18N
        SAIR.setName("SAIR"); // NOI18N
        SAIR.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SAIRActionPerformed(evt);
            }
        });

        Login.setText(resourceMap.getString("Login.text")); // NOI18N
        Login.setName("Login"); // NOI18N

        Senha.setText(resourceMap.getString("Senha.text")); // NOI18N
        Senha.setName("Senha"); // NOI18N
        Senha.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                SenhaKeyPressed(evt);
            }
        });

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(mainPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainPanelLayout.createSequentialGroup()
                                .addComponent(jLabel3)
                                .addGap(18, 18, 18))
                            .addGroup(mainPanelLayout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addGap(15, 15, 15)))
                        .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(Senha)
                            .addComponent(Login, javax.swing.GroupLayout.PREFERRED_SIZE, 190, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(69, 69, 69)
                        .addComponent(Entra_Cadastro_Usuario, javax.swing.GroupLayout.PREFERRED_SIZE, 124, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(mainPanelLayout.createSequentialGroup()
                        .addGap(178, 178, 178)
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 414, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 813, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainPanelLayout.createSequentialGroup()
                        .addContainerGap(691, Short.MAX_VALUE)
                        .addComponent(SAIR, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 55, Short.MAX_VALUE)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Login, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(40, 40, 40)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Senha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Entra_Cadastro_Usuario))
                .addGap(55, 55, 55)
                .addComponent(SAIR)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(81, 81, 81))
        );

        menuBar.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        menuBar.setName("menuBar"); // NOI18N

        Conf_Menu.setText(resourceMap.getString("Conf_Menu.text")); // NOI18N
        Conf_Menu.setName("Conf_Menu"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(modelagemestática.ModelagemEstáticaApp.class).getContext().getActionMap(ModelagemEstáticaView.class, this);
        Conf_Con.setAction(actionMap.get("showAboutBox")); // NOI18N
        Conf_Con.setText(resourceMap.getString("Conf_Con.text")); // NOI18N
        Conf_Con.setName("Conf_Con"); // NOI18N
        Conf_Con.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Conf_ConActionPerformed(evt);
            }
        });
        Conf_Menu.add(Conf_Con);

        menuBar.add(Conf_Menu);

        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        progressBar.setName("progressBar"); // NOI18N

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(statusPanelSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 825, Short.MAX_VALUE)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 655, Short.MAX_VALUE)
                .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addComponent(statusPanelSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel)
                    .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3))
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
        setStatusBar(statusPanel);
    }// </editor-fold>//GEN-END:initComponents

    private void Entra_Cadastro_UsuarioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Entra_Cadastro_UsuarioActionPerformed
        
        Loop_Login(); // teste de login

       

    }//GEN-LAST:event_Entra_Cadastro_UsuarioActionPerformed

    // botão sair
    private void SAIRActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SAIRActionPerformed
        // TODO add your handling code here:
       JFrame mainFrame = ModelagemEstáticaApp.getApplication().getMainFrame();
       mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
       mainFrame.dispose();
       System.exit(0);
    }//GEN-LAST:event_SAIRActionPerformed

    // Configurar Conexão
    private void Conf_ConActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Conf_ConActionPerformed
        // TODO add your handling code here:
       // Config_Conx a = new Config_Conx();
        a.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        a.setVisible(true);


    }//GEN-LAST:event_Conf_ConActionPerformed

    // Botão Enter pressionado
    private void SenhaKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_SenhaKeyPressed
        // TODO add your handling code here:
        if (evt.getKeyCode() == KeyEvent.VK_ENTER){
            Loop_Login();
        }
    }//GEN-LAST:event_SenhaKeyPressed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Entra_Cadastro_Usuario;
    private javax.swing.JTextField Login;
    private javax.swing.JButton SAIR;
    private javax.swing.JPasswordField Senha;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JSeparator jSeparator1;
    public javax.swing.JPanel mainPanel;
    public javax.swing.JMenuBar menuBar;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    // End of variables declaration//GEN-END:variables

    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;

    private JDialog aboutBox;
}
